;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : AT90S8535
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.DEVICE AT90S8535
	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "T_IO_I2C.vec"
	.INCLUDE "T_IO_I2C.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : Test de la carte ES I2C
;      10 Version : 1
;      11 Date    : 29/11/2006
;      12 Author  : Philippe Mariano                
;      13 Company : LYCEE Pierre Emile MARTIN       
;      14 Comments: 
;      15 
;      16 
;      17 Chip type           : AT90S8535
;      18 Clock frequency     : 4,000000 MHz
;      19 Memory model        : Small
;      20 External SRAM size  : 0
;      21 Data Stack size     : 128
;      22 *********************************************/
;      23 
;      24 #include <90s8535.h>
;      25 #include <ssi.h>      // contient les fonctions Lire_BP,Affiche_LCD
;      26 #include <delay.h>    // contient la fonction delay_ms
;      27 #include <stdio.h>    // contient la fonction sprintf
;      28 
;      29 // I2C Bus functions
;      30 #asm
;      31    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      32    .equ __sda_bit=3
   .equ __sda_bit=3
;      33    .equ __scl_bit=7
   .equ __scl_bit=7
;      34 #endasm

;      35 #include <i2c.h>
;      36 
;      37 // Alphanumeric LCD Module functions
;      38 #asm
;      39    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      40 #endasm

;      41 #include <lcd.h>
;      42 
;      43 // Adresses des Ports I2C
;      44 #define AD_BASE_PCF8574		0x40
;      45 #define AD_I2C_PORTA		0
;      46 #define AD_I2C_PORTB		1
;      47 #define AD_I2C_PORTC		2
;      48 #define AD_I2C_PORTD		3
;      49 
;      50 // Declare your global variables here
;      51 /*-----------------------------------------------------------------------------------------
;      52 type 		nom 				       		dsignation       
;      53 ------------------------------------------------------------------------------------------*/
;      54 char display_buffer_ligne0[17]; 			// tampon ligne 0 de l'afficheur
_display_buffer_ligne0:
	.BYTE 0x11
;      55 char display_buffer_ligne1[17]; 	       		// tampon ligne 1 de l'afficheur
_display_buffer_ligne1:
	.BYTE 0x11
;      56 enum Etat_Test {LECTURE_I2C_PORTA,LECTURE_I2C_PORTB,LECTURE_I2C_PORTC, ECRITURE_I2C_PORTD,
;      57  SAISIE_VALEUR, ENVOI_VALEUR} etat=LECTURE_I2C_PORTA, etat_1=LECTURE_I2C_PORTB;// Etats du graphe tests
;      58 
;      59 // Constantes
;      60 const char MENU_E[]="INC>Suiv DEC>PRE"; 

	.CSEG
;      61 
;      62 
;      63 // Prototype des fonctions
;      64 //-------------------------
;      65 unsigned char Lire_PCF8574(unsigned char add);
;      66 unsigned char Ecrire_valeur(unsigned char x, unsigned char y);
;      67 void Ecrire_PCF8574(unsigned char add, unsigned char valeur_portD);
;      68 
;      69 //-----------------------
;      70 // Programme principal
;      71 //-----------------------
;      72 
;      73 void main(void)
;      74 {   // dbut prog
_main:
;      75 // Declare your local variables here
;      76 // -----------------------------------------------------------------------------------------
;      77 //type 		nom 					Commentaires  
;      78 // -------------------------------------------------------------------------------------- --
;      79 unsigned char entrees_A=0, entrees_1_A = 1;	// reoit l'tat du PORT A sur l'I2C
;      80 unsigned char entrees_B=0, entrees_1_B = 1;	// reoit l'tat du PORT B sur l'I2C
;      81 unsigned char entrees_C=0, entrees_1_C = 1;	// reoit l'tat du PORT C sur l'I2C
;      82 unsigned char valeur_portD=0;			// contient la valeur  envoyer sur le PORT D
;      83 unsigned char BP;                               // contient le code du BP appuy (voir SSI.h)
;      84 
;      85 // Input/Output Ports initialization
;      86 // Port A initialization
;      87 // Func0=In Func1=In Func2=In Func3=In Func4=In Func5=In Func6=In Func7=In 
;      88 // State0=P State1=P State2=P State3=P State4=P State5=P State6=T State7=T 
;      89 PORTA=0x3F;
	SBIW R28,2
	LDI  R24,1
	LDI  R26,LOW(1)
	LDI  R27,HIGH(1)
	LDI  R30,LOW(_0x2A*2)
	LDI  R31,HIGH(_0x2A*2)
	RCALL __INITLOCB
;	entrees_A -> R16
;	entrees_1_A -> R17
;	entrees_B -> R18
;	entrees_1_B -> R19
;	entrees_C -> R20
;	entrees_1_C -> R21
;	valeur_portD -> Y+1
;	BP -> Y+0
	LDI  R16,0
	LDI  R17,1
	LDI  R18,0
	LDI  R19,1
	LDI  R20,0
	LDI  R21,1
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;      90 DDRA=0x00;
	CLR  R30
	OUT  0x1A,R30
;      91 
;      92 // Port B initialization
;      93 // Func0=Out Func1=Out Func2=Out Func3=Out Func4=Out Func5=Out Func6=In Func7=In 
;      94 // State0=0 State1=0 State2=0 State3=0 State4=0 State5=0 State6=T State7=T 
;      95 PORTB=0x00;
	OUT  0x18,R30
;      96 DDRB=0x3F;
	LDI  R30,LOW(63)
	OUT  0x17,R30
;      97 
;      98 // I2C Bus initialization
;      99 i2c_init();
	RCALL _i2c_init
;     100 
;     101 // LCD module initialization
;     102 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;     103 
;     104 
;     105 sprintf(display_buffer_ligne0,"Test de la carte");
	RCALL SUBOPT_0x0
	__POINTW1FN _41,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     106 sprintf(display_buffer_ligne1,"****E_S_I2C*****");
	RCALL SUBOPT_0x2
	__POINTW1FN _41,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     107 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x2
	RCALL _Affiche_LCD
;     108 delay_ms(3000);
	LDI  R30,LOW(3000)
	LDI  R31,HIGH(3000)
	RCALL SUBOPT_0x3
;     109 
;     110 
;     111 while (1)
_0x2B:
;     112       {		   // Dbut While(1)  
;     113        
;     114       BP = Lire_BP();
	RCALL _Lire_BP
	ST   Y,R30
;     115       entrees_A = Lire_PCF8574(0);
	RCALL SUBOPT_0x4
	RCALL _Lire_PCF8574
	MOV  R16,R30
;     116       entrees_B = Lire_PCF8574(1);
	RCALL SUBOPT_0x5
	RCALL _Lire_PCF8574
	MOV  R18,R30
;     117       entrees_C = Lire_PCF8574(2);
	RCALL SUBOPT_0x6
	RCALL _Lire_PCF8574
	MOV  R20,R30
;     118       
;     119       switch (etat)
	MOV  R30,R4
;     120        {               // Dbut switch (etat)
;     121         case LECTURE_I2C_PORTA :   if ((etat_1 != etat) || (entrees_A != entrees_1_A))
	CPI  R30,0
	BRNE _0x31
	CP   R4,R5
	BRNE _0x33
	CP   R17,R16
	BREQ _0x32
_0x33:
;     122                         { 
;     123                          sprintf(display_buffer_ligne0,"[E] PORTA = 0x%-x",entrees_A);
	RCALL SUBOPT_0x0
	__POINTW1FN _41,34
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R16
	RCALL SUBOPT_0x7
	LDI  R24,4
	RCALL SUBOPT_0x8
;     124                          sprintf(display_buffer_ligne1,MENU_E);
	RCALL SUBOPT_0x9
	LDI  R24,0
	RCALL SUBOPT_0x1
;     125                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x2
	RCALL _Affiche_LCD
;     126                          entrees_1_A = entrees_A;
	MOV  R17,R16
;     127                         } 
;     128         		if (BP == INC) etat = LECTURE_I2C_PORTB;
_0x32:
	RCALL SUBOPT_0xA
	BRNE _0x35
	RCALL SUBOPT_0xB
;     129        		       	       	else if (BP==DEC) etat = ECRITURE_I2C_PORTD;
	RJMP _0x36
_0x35:
	RCALL SUBOPT_0xC
	BRNE _0x37
	RCALL SUBOPT_0xD
;     130        			       			else etat = LECTURE_I2C_PORTA;
	RJMP _0x38
_0x37:
	CLR  R4
_0x38:
_0x36:
;     131        			etat_1 = LECTURE_I2C_PORTA; 
	CLR  R5
;     132        		        
;     133         break;
	RJMP _0x30
;     134         
;     135         case LECTURE_I2C_PORTB :   if ((etat_1 != etat) || (entrees_B != entrees_1_B))
_0x31:
	CPI  R30,LOW(0x1)
	BRNE _0x39
	CP   R4,R5
	BRNE _0x3B
	CP   R19,R18
	BREQ _0x3A
_0x3B:
;     136                         { 
;     137                          sprintf(display_buffer_ligne0,"[E] PORTB = 0x%-x",entrees_B);
	RCALL SUBOPT_0x0
	__POINTW1FN _41,52
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R18
	RCALL SUBOPT_0x7
	LDI  R24,4
	RCALL SUBOPT_0x8
;     138                          sprintf(display_buffer_ligne1,MENU_E);
	RCALL SUBOPT_0x9
	LDI  R24,0
	RCALL SUBOPT_0x1
;     139                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x2
	RCALL _Affiche_LCD
;     140                          entrees_1_B = entrees_B;
	MOV  R19,R18
;     141                         } 
;     142         		if (BP == INC) etat = LECTURE_I2C_PORTC;
_0x3A:
	RCALL SUBOPT_0xA
	BRNE _0x3D
	RCALL SUBOPT_0xE
;     143        		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTA;
	RJMP _0x3E
_0x3D:
	RCALL SUBOPT_0xC
	BRNE _0x3F
	CLR  R4
;     144        			       			else etat = LECTURE_I2C_PORTB;
	RJMP _0x40
_0x3F:
	RCALL SUBOPT_0xB
_0x40:
_0x3E:
;     145        			etat_1 = LECTURE_I2C_PORTB; 
	LDI  R30,LOW(1)
	MOV  R5,R30
;     146        		        
;     147         break;
	RJMP _0x30
;     148         
;     149         case LECTURE_I2C_PORTC :   if ((etat_1 != etat) || (entrees_C != entrees_1_C))
_0x39:
	CPI  R30,LOW(0x2)
	BRNE _0x41
	CP   R4,R5
	BRNE _0x43
	CP   R21,R20
	BREQ _0x42
_0x43:
;     150                         { 
;     151                          sprintf(display_buffer_ligne0,"[E] PORTC = 0x%-x",entrees_C);
	RCALL SUBOPT_0x0
	__POINTW1FN _41,70
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R20
	RCALL SUBOPT_0x7
	LDI  R24,4
	RCALL SUBOPT_0x8
;     152                          sprintf(display_buffer_ligne1,MENU_E);
	RCALL SUBOPT_0x9
	LDI  R24,0
	RCALL SUBOPT_0x1
;     153                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x2
	RCALL _Affiche_LCD
;     154                          entrees_1_C = entrees_C;
	MOV  R21,R20
;     155                         } 
;     156         		if (BP == INC) etat = ECRITURE_I2C_PORTD;
_0x42:
	RCALL SUBOPT_0xA
	BRNE _0x45
	RCALL SUBOPT_0xD
;     157        		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTB;
	RJMP _0x46
_0x45:
	RCALL SUBOPT_0xC
	BRNE _0x47
	LDI  R30,LOW(1)
	RJMP _0x138
;     158        			       			else etat = LECTURE_I2C_PORTC;
_0x47:
	LDI  R30,LOW(2)
_0x138:
	MOV  R4,R30
_0x46:
;     159        			etat_1 = LECTURE_I2C_PORTC; 
	LDI  R30,LOW(2)
	MOV  R5,R30
;     160        		        
;     161         break; 
	RJMP _0x30
;     162         
;     163         case ECRITURE_I2C_PORTD :   if (etat_1 != etat) 
_0x41:
	CPI  R30,LOW(0x3)
	BRNE _0x49
	CP   R4,R5
	BREQ _0x4A
;     164                         { 
;     165                          sprintf(display_buffer_ligne0,"[S]Val=%-x OK>rgl",valeur_portD);
	RCALL SUBOPT_0x0
	__POINTW1FN _41,88
	RCALL SUBOPT_0xF
	LDI  R24,4
	RCALL SUBOPT_0x8
;     166                          sprintf(display_buffer_ligne1,"SET>envoi val.  ");
	__POINTW1FN _41,106
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     167                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x2
	RCALL _Affiche_LCD
;     168                          }
;     169         		if (BP == INC) etat = LECTURE_I2C_PORTA;
_0x4A:
	RCALL SUBOPT_0xA
	BRNE _0x4B
	CLR  R4
;     170        		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTC;
	RJMP _0x4C
_0x4B:
	RCALL SUBOPT_0xC
	BRNE _0x4D
	RCALL SUBOPT_0xE
;     171        		       	       	                   else if (BP==OK) etat = SAISIE_VALEUR;
	RJMP _0x4E
_0x4D:
	RCALL SUBOPT_0x10
	BRNE _0x4F
	LDI  R30,LOW(4)
	MOV  R4,R30
;     172        		       	       	                   		else if (BP==SET) etat = ENVOI_VALEUR;
	RJMP _0x50
_0x4F:
	LD   R26,Y
	CPI  R26,LOW(0x3D)
	BRNE _0x51
	LDI  R30,LOW(5)
	RJMP _0x139
;     173        			       						else etat = ECRITURE_I2C_PORTD;
_0x51:
	LDI  R30,LOW(3)
_0x139:
	MOV  R4,R30
_0x50:
_0x4E:
_0x4C:
;     174        			etat_1 = ECRITURE_I2C_PORTD; 
	LDI  R30,LOW(3)
	MOV  R5,R30
;     175        			
;     176        		        
;     177         break; 
	RJMP _0x30
;     178        
;     179         case SAISIE_VALEUR :   
_0x49:
	CPI  R30,LOW(0x4)
	BRNE _0x53
;     180                          sprintf(display_buffer_ligne0,"0x%-u  INC>+ DEC>-",valeur_portD);
	RCALL SUBOPT_0x0
	__POINTW1FN _41,123
	RCALL SUBOPT_0xF
	LDI  R24,4
	RCALL SUBOPT_0x8
;     181                          sprintf(display_buffer_ligne1,"OK>suiv ENTR>srt"); 
	__POINTW1FN _41,142
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     182                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x2
	RCALL _Affiche_LCD
;     183                          valeur_portD = Ecrire_valeur(2,0); 
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x4
	RCALL _Ecrire_valeur
	STD  Y+1,R30
;     184                          etat_1 = SAISIE_VALEUR;
	LDI  R30,LOW(4)
	MOV  R5,R30
;     185                          etat = ECRITURE_I2C_PORTD;
	RCALL SUBOPT_0xD
;     186         break;
	RJMP _0x30
;     187         
;     188         case ENVOI_VALEUR : if (etat_1 != etat)
_0x53:
	CPI  R30,LOW(0x5)
	BRNE _0x30
	CP   R4,R5
	BREQ _0x55
;     189         		{  
;     190                          sprintf(display_buffer_ligne0,"[S] PORTD = 0x%-x",valeur_portD);
	RCALL SUBOPT_0x0
	__POINTW1FN _41,159
	RCALL SUBOPT_0xF
	LDI  R24,4
	RCALL SUBOPT_0x8
;     191                          sprintf(display_buffer_ligne1,"OK>rgl INC DEC");
	__POINTW1FN _41,177
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x1
;     192                          Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x2
	RCALL _Affiche_LCD
;     193                          Ecrire_PCF8574(AD_I2C_PORTD,valeur_portD);  
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL SUBOPT_0x11
	RCALL _Ecrire_PCF8574
;     194           		}
;     195                          if (BP == INC) etat = LECTURE_I2C_PORTA;
_0x55:
	RCALL SUBOPT_0xA
	BRNE _0x56
	CLR  R4
;     196        		       	       	else if (BP==DEC) etat = LECTURE_I2C_PORTC;
	RJMP _0x57
_0x56:
	RCALL SUBOPT_0xC
	BRNE _0x58
	RCALL SUBOPT_0xE
;     197        		       	       	                   else if (BP==OK) etat = ECRITURE_I2C_PORTD; 
	RJMP _0x59
_0x58:
	RCALL SUBOPT_0x10
	BRNE _0x5A
	LDI  R30,LOW(3)
	RJMP _0x13A
;     198        		       	       	                   		else etat = ENVOI_VALEUR;
_0x5A:
	LDI  R30,LOW(5)
_0x13A:
	MOV  R4,R30
_0x59:
_0x57:
;     199        			 etat_1 = ENVOI_VALEUR;
	LDI  R30,LOW(5)
	MOV  R5,R30
;     200         break;
;     201         
;     202         } //fin du switch
_0x30:
;     203       } // fin du while
	RJMP _0x2B
;     204 } // fin prog
	ADIW R28,2
_0x5C:
	RJMP _0x5C
;     205 
;     206 unsigned char Lire_PCF8574(unsigned char add)
;     207 {
_Lire_PCF8574:
;     208   unsigned char entrees;
;     209   i2c_start();
	ST   -Y,R16
;	add -> Y+1
;	entrees -> R16
	RCALL SUBOPT_0x12
;     210   i2c_write(0x41 | add << 1);
	ORI  R30,LOW(0x41)
	RCALL SUBOPT_0x13
;     211   entrees = i2c_read(0);
	RCALL SUBOPT_0x4
	RCALL _i2c_read
	MOV  R16,R30
;     212   i2c_stop();
	RCALL _i2c_stop
;     213   return entrees;    
	MOV  R30,R16
	LDD  R16,Y+0
	RJMP _0x137
;     214 } 
;     215 
;     216 void Ecrire_PCF8574(unsigned char add, unsigned char valeur_portD)
;     217 {
_Ecrire_PCF8574:
;     218   i2c_start();
	RCALL SUBOPT_0x12
;     219   i2c_write(0x40 | add << 1);
	ORI  R30,0x40
	RCALL SUBOPT_0x13
;     220   i2c_write(valeur_portD);
	LD   R30,Y
	RCALL SUBOPT_0x13
;     221   i2c_stop();
	RCALL _i2c_stop
;     222   delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL SUBOPT_0x3
;     223 }
_0x137:
	ADIW R28,2
	RET
;     224 
;     225 unsigned char Ecrire_valeur(unsigned char x, unsigned char y)
;     226 {    
_Ecrire_valeur:
;     227  unsigned char BP, etat=0, etat_1=1; 
;     228  int dizaines=0, dizaines_1 = 1, unites = 0, unites_1 = 1;
;     229  unsigned char Table_aff[16] = {'0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F'};
;     230  
;     231  _lcd_write_data(displayOff3);
	SBIW R28,22
	LDI  R24,22
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x60*2)
	LDI  R31,HIGH(_0x60*2)
	RCALL __INITLOCB
	RCALL __SAVELOCR5
;	x -> Y+28
;	y -> Y+27
;	BP -> R16
;	etat -> R17
;	etat_1 -> R18
;	dizaines -> R19,R20
;	dizaines_1 -> Y+25
;	unites -> Y+23
;	unites_1 -> Y+21
;	Table_aff -> Y+5
	LDI  R17,0
	LDI  R18,1
	LDI  R19,0
	LDI  R20,0
	LDI  R30,LOW(11)
	RCALL SUBOPT_0x14
;     232  
;     233  while(1)
_0x61:
;     234   {
;     235    BP = Lire_BP();
	RCALL _Lire_BP
	MOV  R16,R30
;     236    switch (etat)
	MOV  R30,R17
;     237 	{
;     238 	  case 0 : // Rglage des dizaines
	CPI  R30,0
	BRNE _0x67
;     239                    if (dizaines==-1) dizaines = 15;
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	CP   R30,R19
	CPC  R31,R20
	BRNE _0x68
	__GETWRN 19,20,15
;     240         		else if (dizaines == 16) dizaines = 0;
	RJMP _0x69
_0x68:
	LDI  R30,LOW(16)
	LDI  R31,HIGH(16)
	CP   R30,R19
	CPC  R31,R20
	BRNE _0x6A
	__GETWRN 19,20,0
;     241         		
;     242    		   if ((dizaines_1 != dizaines) || (etat_1 != etat))
_0x6A:
_0x69:
	LDD  R26,Y+25
	LDD  R27,Y+25+1
	CP   R19,R26
	CPC  R20,R27
	BRNE _0x6C
	CP   R17,R18
	BREQ _0x6B
_0x6C:
;     243         		{
;     244         		  lcd_gotoxy(x,y);
	RCALL SUBOPT_0x15
	RCALL SUBOPT_0x15
	RCALL _lcd_gotoxy
;     245         	          lcd_putchar(Table_aff[dizaines]);
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,5
	ADD  R26,R19
	ADC  R27,R20
	RCALL SUBOPT_0x16
;     246         	          dizaines_1 = dizaines;
	__PUTWSR 19,20,25
;     247         	   	}
;     248         	   switch(BP)
_0x6B:
	RCALL SUBOPT_0x17
;     249         	   	{
;     250         	    	  case INC   : dizaines = dizaines + 1; break;
	BRNE _0x71
	__ADDWRN 19,20,1
	RJMP _0x70
;     251         	    	  case DEC   : dizaines = dizaines - 1; break;
_0x71:
	CPI  R30,LOW(0x2F)
	BRNE _0x72
	__SUBWRN 19,20,1
	RJMP _0x70
;     252         	    	  case OK    : etat = 1; break;
_0x72:
	CPI  R30,LOW(0x37)
	BRNE _0x73
	LDI  R17,LOW(1)
	RJMP _0x70
;     253         	   	  case ENTR  : etat = 2; break;
_0x73:
	CPI  R30,LOW(0x3E)
	BRNE _0x75
	LDI  R17,LOW(2)
	RJMP _0x70
;     254         	    	  default    : etat = 0;
_0x75:
	LDI  R17,LOW(0)
;     255         	    	}
_0x70:
;     256         	    	  etat_1 = 0; 	   
	LDI  R18,LOW(0)
;     257 	  break;
	RJMP _0x66
;     258 	  
;     259 	  case 1 : // Rglage des unites
_0x67:
	CPI  R30,LOW(0x1)
	BREQ PC+2
	RJMP _0x76
;     260                    if (unites==-1) unites = 15;
	LDD  R26,Y+23
	LDD  R27,Y+23+1
	CPI  R26,LOW(0xFFFF)
	LDI  R30,HIGH(0xFFFF)
	CPC  R27,R30
	BRNE _0x77
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	STD  Y+23,R30
	STD  Y+23+1,R31
;     261         		else if (unites == 16) unites = 0;  
	RJMP _0x78
_0x77:
	LDD  R26,Y+23
	LDD  R27,Y+23+1
	CPI  R26,LOW(0x10)
	LDI  R30,HIGH(0x10)
	CPC  R27,R30
	BRNE _0x79
	CLR  R30
	STD  Y+23,R30
	STD  Y+23+1,R30
;     262         		
;     263    		   if ((unites_1 != unites) || (etat_1 != etat))
_0x79:
_0x78:
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	LDD  R26,Y+21
	LDD  R27,Y+21+1
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x7B
	CP   R17,R18
	BREQ _0x7A
_0x7B:
;     264         		{
;     265                           lcd_gotoxy(x+1,y);
	LDD  R30,Y+28
	SUBI R30,-LOW(1)
	ST   -Y,R30
	RCALL SUBOPT_0x15
	RCALL _lcd_gotoxy
;     266         	          lcd_putchar(Table_aff[unites]);
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,5
	ADD  R26,R30
	ADC  R27,R31
	RCALL SUBOPT_0x16
;     267         	          unites_1 = unites;
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	STD  Y+21,R30
	STD  Y+21+1,R31
;     268         	   	}
;     269         	   switch(BP)
_0x7A:
	RCALL SUBOPT_0x17
;     270         	   	{
;     271         	    	  case INC   : unites = unites + 1; break;
	BRNE _0x80
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	ADIW R30,1
	STD  Y+23,R30
	STD  Y+23+1,R31
	RJMP _0x7F
;     272         	    	  case DEC   : unites = unites - 1; break;
_0x80:
	CPI  R30,LOW(0x2F)
	BRNE _0x81
	LDD  R30,Y+23
	LDD  R31,Y+23+1
	SBIW R30,1
	STD  Y+23,R30
	STD  Y+23+1,R31
	RJMP _0x7F
;     273         	    	  case OK    : etat = 0; break;
_0x81:
	CPI  R30,LOW(0x37)
	BRNE _0x82
	LDI  R17,LOW(0)
	RJMP _0x7F
;     274         	   	  case ENTR  : etat = 2; break;
_0x82:
	CPI  R30,LOW(0x3E)
	BRNE _0x84
	LDI  R17,LOW(2)
	RJMP _0x7F
;     275         	    	  default    : etat = 1;
_0x84:
	LDI  R17,LOW(1)
;     276         	    	}
_0x7F:
;     277         	    	  etat_1 = 1; 
	LDI  R18,LOW(1)
;     278 	  break;
	RJMP _0x66
;     279 	  
;     280 	  case 2 : _lcd_write_data(displayOn0);
_0x76:
	CPI  R30,LOW(0x2)
	BRNE _0x66
	RCALL SUBOPT_0x18
;     281 	  	   return (unsigned char)(16*dizaines + unites);
	__GETW1R 19,20
	RCALL __LSLW4
	LDD  R26,Y+23
	LDD  R27,Y+23+1
	ADD  R30,R26
	ADC  R31,R27
	RJMP _0x136
;     282 	  break;
;     283 	  
;     284 	}
_0x66:
;     285    }
	RJMP _0x61
;     286 }
_0x136:
	RCALL __LOADLOCR5
	ADIW R28,29
	RET
;     287 
;     288  
_Lire_BP:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	RCALL SUBOPT_0x19
	MOV  R30,R6
	CPI  R30,0
	BRNE _0x8A
	CPI  R17,63
	BRNE _0x8B
	MOV  R16,R17
	RCALL SUBOPT_0x1A
	RCALL SUBOPT_0x19
	CP   R17,R16
	BRNE _0x8C
	LDI  R30,LOW(1)
	MOV  R6,R30
	LDI  R30,LOW(255)
	RJMP _0x135
_0x8C:
	CLR  R30
	RJMP _0x135
	RJMP _0x8E
_0x8B:
	CLR  R30
	RJMP _0x135
_0x8E:
	RJMP _0x89
_0x8A:
	CPI  R30,LOW(0x1)
	BRNE _0x89
	CPI  R17,63
	BREQ _0x90
	MOV  R16,R17
	RCALL SUBOPT_0x1A
	ANDI R17,LOW(63)
	CP   R17,R16
	BRNE _0x91
	CLR  R6
	MOV  R30,R17
	RJMP _0x135
_0x91:
	LDI  R30,LOW(255)
	RJMP _0x135
	RJMP _0x93
_0x90:
	LDI  R30,LOW(255)
_0x93:
_0x89:
_0x135:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0x1B
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x5
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0x1B
	ADIW R28,4
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0x1C
	SBIW R30,0
	BREQ _0xCB
	RCALL SUBOPT_0x1C
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOV  R26,R30
	MOV  R27,R31
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0xCC
_0xCB:
	RCALL SUBOPT_0x11
	RCALL _putchar
_0xCC:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0xCE:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM
	MOV  R30,R0
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0xD0
	MOV  R30,R16
	CPI  R30,0
	BRNE _0xD4
	CPI  R19,37
	BRNE _0xD5
	LDI  R16,LOW(1)
	RJMP _0xD6
_0xD5:
	RCALL SUBOPT_0x1D
_0xD6:
	RJMP _0xD3
_0xD4:
	CPI  R30,LOW(0x1)
	BRNE _0xD7
	CPI  R19,37
	BRNE _0xD8
	RCALL SUBOPT_0x1D
	LDI  R16,LOW(0)
	RJMP _0xD3
_0xD8:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0xD9
	LDI  R17,LOW(1)
	RJMP _0xD3
_0xD9:
	CPI  R19,43
	BRNE _0xDA
	LDI  R21,LOW(43)
	RJMP _0xD3
_0xDA:
	CPI  R19,32
	BRNE _0xDB
	LDI  R21,LOW(32)
	RJMP _0xD3
_0xDB:
	RJMP _0xDC
_0xD7:
	CPI  R30,LOW(0x2)
	BRNE _0xDD
_0xDC:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0xDE
	ORI  R17,LOW(128)
	RJMP _0xD3
_0xDE:
	RJMP _0xDF
_0xDD:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xD3
_0xDF:
	CPI  R19,48
	BRLO _0xE2
	CPI  R19,58
	BRLO _0xE3
_0xE2:
	RJMP _0xE1
_0xE3:
	MOV  R18,R20
	LSL  R20
	LSL  R20
	ADD  R20,R18
	LSL  R20
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0xD3
_0xE1:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0xE7
	RCALL SUBOPT_0x1E
	LD   R30,X
	RCALL SUBOPT_0x1F
	RJMP _0xE8
_0xE7:
	CPI  R30,LOW(0x73)
	BRNE _0xEA
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x20
	RCALL _strlen
	MOV  R16,R30
	RJMP _0xEB
_0xEA:
	CPI  R30,LOW(0x70)
	BRNE _0xED
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x20
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0xEB:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0xEE
_0xED:
	CPI  R30,LOW(0x64)
	BREQ _0xF1
	CPI  R30,LOW(0x69)
	BRNE _0xF2
_0xF1:
	ORI  R17,LOW(4)
	RJMP _0xF3
_0xF2:
	CPI  R30,LOW(0x75)
	BRNE _0xF4
_0xF3:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0xF5
_0xF4:
	CPI  R30,LOW(0x58)
	BRNE _0xF7
	ORI  R17,LOW(8)
	RJMP _0xF8
_0xF7:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x126
_0xF8:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0xF5:
	SBRS R17,2
	RJMP _0xFA
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x21
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0xFB
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0xFB:
	CPI  R21,0
	BREQ _0xFC
	SUBI R16,-LOW(1)
	RJMP _0xFD
_0xFC:
	ANDI R17,LOW(251)
_0xFD:
	RJMP _0xFE
_0xFA:
	RCALL SUBOPT_0x1E
	RCALL SUBOPT_0x21
_0xFE:
_0xEE:
	SBRC R17,0
	RJMP _0xFF
_0x100:
	CP   R16,R20
	BRSH _0x102
	SBRS R17,7
	RJMP _0x103
	SBRS R17,2
	RJMP _0x104
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0x105
_0x104:
	LDI  R19,LOW(48)
_0x105:
	RJMP _0x106
_0x103:
	LDI  R19,LOW(32)
_0x106:
	RCALL SUBOPT_0x1D
	SUBI R20,LOW(1)
	RJMP _0x100
_0x102:
_0xFF:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0x107
_0x108:
	CPI  R18,0
	BREQ _0x10A
	SBRS R17,3
	RJMP _0x10B
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM
	MOV  R30,R0
	RJMP _0x13B
_0x10B:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x13B:
	ST   -Y,R30
	RCALL SUBOPT_0x22
	CPI  R20,0
	BREQ _0x10D
	SUBI R20,LOW(1)
_0x10D:
	SUBI R18,LOW(1)
	RJMP _0x108
_0x10A:
	RJMP _0x10E
_0x107:
_0x110:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0x112
	SBRS R17,3
	RJMP _0x113
	SUBI R19,-LOW(7)
	RJMP _0x114
_0x113:
	SUBI R19,-LOW(39)
_0x114:
_0x112:
	SBRC R17,4
	RJMP _0x116
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0x118
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0x117
_0x118:
	ORI  R17,LOW(16)
	RJMP _0x11A
_0x117:
	CP   R20,R18
	BRLO _0x11C
	SBRS R17,0
	RJMP _0x11D
_0x11C:
	RJMP _0x11B
_0x11D:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0x11E
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0x11A:
	SBRS R17,2
	RJMP _0x11F
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x22
	CPI  R20,0
	BREQ _0x120
	SUBI R20,LOW(1)
_0x120:
_0x11F:
_0x11E:
_0x116:
	RCALL SUBOPT_0x1D
	CPI  R20,0
	BREQ _0x121
	SUBI R20,LOW(1)
_0x121:
_0x11B:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0x111
	RJMP _0x110
_0x111:
_0x10E:
	SBRS R17,0
	RJMP _0x122
_0x123:
	CPI  R20,0
	BREQ _0x125
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x1F
	RJMP _0x123
_0x125:
_0x122:
_0x126:
_0xE8:
	LDI  R16,LOW(0)
_0xD3:
	RJMP _0xCE
_0xD0:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOV  R26,R28
	MOV  R27,R29
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,6
	RCALL SUBOPT_0x23
	ST   Y,R30
	STD  Y+1,R31
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,4
	RCALL SUBOPT_0x23
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G4:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G4:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G4)
	SBCI R31,HIGH(-__base_y_G4)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x14
	LDD  R7,Y+1
	LDD  R8,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	RCALL SUBOPT_0x6
	RCALL __lcd_write_data
	RCALL __lcd_ready
	RCALL SUBOPT_0x18
	RCALL __lcd_ready
	RCALL SUBOPT_0x5
	RCALL __lcd_write_data
	CLR  R30
	MOV  R8,R30
	MOV  R7,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R7
	CP   R9,R7
	BRSH _0x12E
	__lcd_putchar1:
	INC  R8
	RCALL SUBOPT_0x4
	ST   -Y,R8
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x12E:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G4:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G4:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R9,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G4,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G4,3
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x24
	RCALL SUBOPT_0x24
	RCALL __long_delay_G4
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G4
	RCALL __long_delay_G4
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x14
	RCALL __long_delay_G4
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x14
	RCALL __long_delay_G4
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x14
	RCALL __long_delay_G4
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G4
	CPI  R30,LOW(0x5)
	BREQ _0x133
	CLR  R30
	RJMP _0x134
_0x133:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x14
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x134:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(_display_buffer_ligne0)
	LDI  R31,HIGH(_display_buffer_ligne0)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x1:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 14 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(_display_buffer_ligne1)
	LDI  R31,HIGH(_display_buffer_ligne1)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x3:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x4:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x6:
	LDI  R30,LOW(2)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x7:
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES
SUBOPT_0x8:
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(_MENU_E*2)
	LDI  R31,HIGH(_MENU_E*2)
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xA:
	LD   R26,Y
	CPI  R26,LOW(0x1F)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LDI  R30,LOW(1)
	MOV  R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0xC:
	LD   R26,Y
	CPI  R26,LOW(0x2F)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xD:
	LDI  R30,LOW(3)
	MOV  R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xE:
	LDI  R30,LOW(2)
	MOV  R4,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xF:
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+5
	RJMP SUBOPT_0x7

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x10:
	LD   R26,Y
	CPI  R26,LOW(0x37)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	LDD  R30,Y+2
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	RCALL _i2c_start
	LDD  R30,Y+1
	LSL  R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x13:
	ST   -Y,R30
	RJMP _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x14:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x15:
	LDD  R30,Y+28
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x16:
	LD   R30,X
	ST   -Y,R30
	RJMP _lcd_putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x17:
	MOV  R30,R16
	CPI  R30,LOW(0x1F)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x18:
	LDI  R30,LOW(12)
	RJMP SUBOPT_0x14

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x19:
	IN   R30,0x19
	ANDI R30,LOW(0x3F)
	MOV  R17,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1A:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1B:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1C:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x1D:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x1E:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1F:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x20:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x21:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x22:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x23:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x24:
	RCALL __long_delay_G4
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G4

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,7
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,13
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm 
	tst  r0
	breq __strlenf1
	adiw r26,1
	adiw r30,1
	rjmp __strlenf0
__strlenf1:
	mov  r30,r26
	mov  r31,r27
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__LSLW4:
	LSL  R30
	ROL  R31
__LSLW3:
	LSL  R30
	ROL  R31
__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM 
	MOV  R31,R0
	MOV  R30,R1
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM
	ADIW R30,1
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

